const jsdom = require('jsdom');
const process = require('process');
const Genius = require("node-genius");
// default token - you can generate your own at docs.genius.com
const geniusClient = new Genius('Wd5-iUH0HjDKBDY3PUztzeo-PiG-34FQKY9tkjH4XfLpG798We7M2blo3xGfQLAO');
const colors = require('colors')
const term = require('terminal-kit').terminal;
const readline = require('readline');
const ora = require('ora');

const rl = readline.createInterface({
    input: process.stdin,
    output: process.stdout,
});
var spinner = ora({
    text: "Searching for tracks...",
    spinner : "pipe",
    color: "cyan"
}).start();

let q = process.argv[2];
if (q == undefined || q == null || q == "") {
    spinner.text = "No track provided";
    spinner.fail();
    process.exit();
}

function genius() {
    geniusClient.search(q, function(error, results) {
        if (error) {
            spinner.text = error;
            spinner.fail();
        }
        let hits = JSON.parse(results).response.hits;
        if (hits.length > 0) {


            spinner.succeed()

            hits.forEach(function(element, index) {
                console.log(`\n${index} >>`.green.bold, element.result.full_title)
            });

            rl.setPrompt("\nEnter track number >>> ".green)
            rl.prompt();

            rl.on('line', (line) => {
                line = parseInt(line)

                if (Array.apply(null, { length: hits.length }).map(Number.call, Number).indexOf(line) === -1) {
                    console.log(`Not a valid track number, Please try again`.red);
                    rl.prompt();
                } else {

                    let answer = line;
                    console.log(`\nTrack Selected: ${answer}\n`);
                    let path = hits[answer].result.path;
                    let title = hits[answer].result.full_title;
                    let url = `https://www.genius.com${path}`;

                    spinner.clear();
                    spinner.text = "Fetching lyrics..."
                    spinner.start();

                    jsdom.env(
                        `https://genius.com${path}`,
                        function(err, window) {
                            if (err) {
                                console.log(err);
                            }
                            spinner.succeed();
                            let output = `${'_'.repeat(title.length + 1)}\n\n${title}\n${url}\n${'_'.repeat(title.length + 1)}`
                            term.eraseDisplay();
                            term.bell();
                            console.log(output.green.bold);
                            let lyrics = window.document.getElementsByClassName('lyrics')[0].textContent.trim();

                            console.log(`\n${lyrics}\n`);
                            process.exit();
                        }
                    );
                }
            }).on('close', () => {
                console.log('Bye 😘\n');
                process.exit(0);
            });
        } else {
            spinner.text = "No tracks found with this title\n".red.bold
            spinner.fail();
            process.exit();
        }
    });
}



module.exports = genius;
